//+------------------------------------------------------------------+
//|                                                          mts.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "denkir@gmail.com"
#property version   "1.00"
//---  
input int      K=3;              //      21/55:   "K"   Position handling   K-Delay
input int      TakeProfit = 295;   // Take Profit:  Take Profit   FromWorkspace
input int      StopLoss = 65;      // Stop Loss:  Stop Loss   FromWorkspace
input int      MA1_Period = 21;     //  Moving Average 1
input int      MA2_Period= 55;      //  Moving Average 2
input int      Magic=76767;   // Magic Number 

//---  
double   Lot=1; //    :   "Lots"   Position handling
int ma1Handle;  //   Moving Average 1:  "ema21 signal"
int ma2Handle;  //   Moving Average 2:  "ema55 signal"

double ma1Val[]; //       Moving Average 1   :  "ema21 signal"
double ma2Val[]; //       Moving Average 2   :  "ema55 signal"

int sl,tp;    //     Stop Loss  Take Profit 
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
bool IsTraded(bool IsBought,bool IsSold)
  {
   if(IsSold || IsBought)
     {
      Alert("  ");
      return(true);
     }
   else
      return(false);
  }
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---   
   if(Bars(_Symbol,_Period)<56) // 1-   Position handling:  [Input.num>=56]
     {
      Alert(" !");
      return(-1);
     }

   ma1Handle=iMA(_Symbol,_Period,MA1_Period,0,MODE_EMA,PRICE_CLOSE);//  Moving Average 1:  "ema21 signal"
   ma2Handle=iMA(_Symbol,_Period,MA2_Period,0,MODE_EMA,PRICE_CLOSE);//  Moving Average 2:  "ema55 signal"
//---   Invalid Handle
   if(ma1Handle<0 || ma2Handle<0)
     {
      Alert("    -  : ",GetLastError(),"!!");
      return(-1);
     }
//---    ,  5-  ,
//---   10  SL  TP
   sl = StopLoss;
   tp = TakeProfit;
   if(_Digits==5)
     {
      sl = sl*10;
      tp = tp*10;
     }

   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---   
   IndicatorRelease(ma1Handle);
   IndicatorRelease(ma2Handle);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {

//    
   static datetime Old_Time;
//static datetime Open_Time; //  ,     
   datetime New_Time[1];
   bool IsNewBar=false;
   int copied=CopyTime(_Symbol,_Period,0,1,New_Time);
   if(copied>0)
     {
      if(Old_Time!=New_Time[0])
        {
         IsNewBar=true;
         Old_Time=New_Time[0];
        }
     }
   else
     {
      Alert("Error =",GetLastError());
      ResetLastError();
      return;
     }
   if(IsNewBar==false)
     {
      return;
     }

//---  ,     
   MqlTick latest_price;       //     
   MqlTradeRequest mrequest;   //      
   MqlTradeResult mresult;     //        
   MqlRates mrate[];           //   ,      
/*
            
       
*/
   ArraySetAsSeries(mrate,true); //  
   ArraySetAsSeries(ma1Val,true);//    MA 1:  "ema21 signal"
   ArraySetAsSeries(ma2Val,true);//    MA 2:  "ema55 signal"

//---        MqlTick
   if(!SymbolInfoTick(_Symbol,latest_price))
     {
      Alert("    - :",GetLastError(),"!!");
      return;
     }

//---     2+K- 
   if(CopyRates(_Symbol,_Period,0,2+K,mrate)<0)
     {
      Alert("    - :",GetLastError(),"!!");
      return;
     }

//--- Copy the new values of our indicators to buffers (arrays) using the handle
   if(CopyBuffer(ma1Handle,0,0,2+K,ma1Val)<0)
     {
      Alert("    Moving Average 1 -  :",GetLastError());
      return;
     }
   if(CopyBuffer(ma2Handle,0,0,2+K,ma2Val)<0)
     {
      Alert("    Moving Average 2 -  :",GetLastError());
      return;
     }
//--- 1-   Position handling:  [Input.num>Output.barClose]
   bool IsBought=false;  // 
   bool IsSold=false; // 

   if(PositionSelect(_Symbol)==true)
     {
      if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
        {
         IsBought=true;  //long
        }
      else if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
        {
         IsSold=true; // short
        }
     }

/*
        : EMA 21  1+K-   EMA 55, EMA 21  K-   EMA 55
    
*/
/*    :  "emas differential"; 
       K :  "K Delay"    
     Buy (  )
*/
   bool Buy=((ma2Val[1+K]-ma1Val[1+K])>=0 && (ma2Val[K]-ma1Val[K])<0) || ((ma2Val[1+K]-ma1Val[1+K])>0 && (ma2Val[K]-ma1Val[K])==0);
//  OpenBuy:  "Position opening"
//  OpenBuy:  "Position handling",    
   if(Buy)
     {
      if(IsTraded(IsBought,IsSold)){
         return;} //    
      // 4-   Position handling:   
      mrequest.action = TRADE_ACTION_DEAL;                                  //   
      mrequest.price = NormalizeDouble(latest_price.ask,_Digits);           //   ask
      mrequest.sl = NormalizeDouble(latest_price.bid - sl*_Point,_Digits); //  Stop Loss
      mrequest.tp = NormalizeDouble(latest_price.bid + tp*_Point,_Digits); //  Take Profit
      mrequest.symbol = _Symbol;                                            // 
      mrequest.volume = Lot;                                                //  
      mrequest.magic=Magic;                                            // Magic Number
      mrequest.type = ORDER_TYPE_BUY;                                       //   
      mrequest.type_filling = ORDER_FILLING_AON;                            //            
      mrequest.deviation=100;                                               //  
      OrderSend(mrequest,mresult);
      if(mresult.retcode==10009 || mresult.retcode==10008) //     
        {
         //Open_Time=New_Time[0];
         Alert("   ,  #:",mresult.order);
        }
      else
        {
         Alert("    ; :",GetLastError());
         return;
        }
     }
/*
        : EMA 21  1+K-   EMA 55, EMA 21  K-   EMA 55
*/

/*    :  "emas differential"; 
       K :  "K Delay"    
     Sell (  )
*/
   bool Sell=((ma2Val[1+K]-ma1Val[1+K])<=0 && (ma2Val[K]-ma1Val[K])>0) || ((ma2Val[1+K]-ma1Val[1+K])<0 && (ma2Val[K]-ma1Val[K])==0);
//  OpenSell:  "Position opening"
//  OpenSell:  "Position handling",    
   if(Sell)
     {
      if(IsTraded(IsBought,IsSold)){
         return;} //    
      // 5-   Position handling:   
      mrequest.action = TRADE_ACTION_DEAL;                                  //   
      mrequest.price = NormalizeDouble(latest_price.bid,_Digits);           //   bid
      mrequest.sl=NormalizeDouble(latest_price.ask+sl*_Point,_Digits); //  Stop Loss
      mrequest.tp=NormalizeDouble(latest_price.ask-tp*_Point,_Digits); //  Take Profit
      mrequest.symbol = _Symbol;                                            // 
      mrequest.volume = Lot;                                                //  
      mrequest.magic=Magic;                                            // Magic Number
      mrequest.type= ORDER_TYPE_SELL;                                       //   
      mrequest.type_filling = ORDER_FILLING_AON;                            //            
      mrequest.deviation=100;                                               //  
      OrderSend(mrequest,mresult);
      if(mresult.retcode==10009 || mresult.retcode==10008) //     
        {
         Alert("   ,  #:",mresult.order);
        }
      else
        {
         //Open_Time=New_Time[0];
         Alert("    ; :",GetLastError());
         return;
        }
     }
   return;

//+------------------------------------------------------------------+
  }
//+------------------------------------------------------------------+
